/***************************************************************************
 *   Copyright (C) 2005 by Siegfried Nijssen                               *
 *   snijssen@informatik.uni-freiburg.de                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GDATABASE_H
#define GDATABASE_H
#include <vector>
#include <map>
#include "global.h"
#include "ggraph.h"
#include "ggraphcode.h"

struct GTokenDatabaseData {
  vector<GTid> tids;
  vector<GFrequency> frequency;
  GTokenDatabaseData (): frequency ( MAXCLASS ) { }
};

struct GGraphClassData:public GGraphExtraData {
  GClassNumber classnumber;
};

/**
@author Siegfried Nijssen
*/
class GDatabase{
    void process ( GGraph *graph );
public:
    GDatabase();
    ~GDatabase();
    
    void read ( string filename, GClassNumber classnumber );
    
    vector<GGraph*> graphs;
    map<GToken,GTokenDatabaseData,GTokenLt> tokendata;
    vector<GFrequency> classsizes;
};

#endif
