/***************************************************************************
 *   Copyright (C) 2005 by Siegfried Nijssen                               *
 *   snijssen@informatik.uni-freiburg.de                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef GTRIE_H
#include <algorithm>

//#include "gtrie.h"

template<class T1,class T2>
GTrie<T1,T2>::GTrie()
{
}


template<class T1,class T2>
GTrie<T1,T2>::~GTrie()
{
}

template<class T1,class T2>
struct GTrieNodeLt {
  bool operator()(const GTrieNode<T1,T2> *v1, T1 *v2 ) const
  {
    return v1->key < *v2;
  }
};


template<class T1,class T2>
pair<GTrieNode<T1,T2>*,bool> GTrie<T1,T2>::insert ( vector<T1> &elements, GTrieNode<T1,T2>* starti, int startpos ) {
  pair<GTrieNode<T1,T2>*,bool> ret;
  ret.first = NULL;
  ret.second = false;
  
  vector<GTrieNode<T1,T2> *> *ps;
  typename vector<T1>::iterator walk;
   
   if ( starti ) {
     walk = elements.begin () + startpos + 1;
     ps = &starti->children;
   }
   else {
     walk = elements.begin ();
     ps = &roots;
   }

  for ( ; walk != elements.end (); ++walk ) {
    typename vector<GTrieNode<T1,T2> *>::iterator p;
    if ( !ret.second ) {
      p = lower_bound ( ps->begin (), ps->end (), & ( *walk ), GTrieNodeLt<T1,T2> () );
    
      if ( p != ps->end () && ( *p )->key == *walk ) {
        ps = & ( *p )->children;
        ret.first = *p;
      }
      else 
        ret.second = true;
    }
    else 
      p = ps->end ();
      
    if ( ret.second ) {
      ret.first = new GTrieNode<T1,T2>;
      ret.first->key = *walk;
      ps->insert ( p, ret.first );
      ps = &ret.first->children;
    }
  }
  
  return ret;
}


#endif
