/***************************************************************************
 *   Copyright (C) 2005 by Siegfried Nijssen                               *
 *   snijssen@informatik.uni-freiburg.de                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GTRIE_H
#define GTRIE_H
#include <vector>
using namespace std;

template<class T1,class T2>
class GTrieNode {
public:
    T1 key;
    T2 value;
    vector<GTrieNode*> children;
};

/**
@author Siegfried Nijssen
*/
template<class T1,class T2>
class GTrie{
public:    
    vector<GTrieNode<T1,T2> *> roots;
    
    GTrie();

    ~GTrie();
    
    pair<GTrieNode<T1,T2>*,bool> insert ( vector<T1> &elements, GTrieNode<T1,T2>* starti = NULL, int startpos = 0 );
};

#include "gtrie.cpp"

#endif
