import openbabel, pybel
import numpy as np
import sys

def parseGSPFile(inputFile):
	f = open(inputFile,'r')

	print("%s\n" % inputFile)
	molCounter = 0
	
	for line in f:
		try:
			if '#' in line:
				mol = openbabel.OBMol()
				molCounter+=1
				print("Molecule %d\n" % molCounter)
				line = f.next()
				while 'v' in line:
					data = line.split(' ')
					element = np.int(data[2])
					a = mol.NewAtom()
					a.SetAtomicNum(element)
					line = f.next()
				while 'e' in line:
					data = line.split(' ')
					vertice1 = np.int(data[1])
					vertice2 = np.int(data[2])
					mol.AddBond(vertice1+1, vertice2+1, np.int(data[3]))
					line = f.next()
				pybelMol = pybel.Molecule(mol)
				print("%d %s\n" % (len(pybelMol.atoms),pybelMol.write()))
				pybelMol.removeh()
#				for atom in pybelMol:
#				    print atom  
				pybelMol.draw(True,None,True,False)
#				for atom in pybelMol:
#				    print atom  
				sys.stdin.read(1)
		except ValueError:
			print "Invalid input:", line
	f.close()


parseGSPFile("classifier/top_sg_1_100.gsp")
parseGSPFile("input/test.gsp")
