#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import sys
import logging

def usage():

    print ("prepep_load_subgraph [classifier] [subgraph]")

def load_all_subgraphs_by_classifier_id(classifier_id):

    logging.info("loading subgraphs from top_sg_%s.gsp" % (str(classifier_id + 1)))

    f = open('classifier/top_sg_' + str(classifier_id + 1) + '.gsp', 'r')

    buff_str_list = []
    buff_str = ''
    for line in f:
        try:
            if '#' in line:
                while ('#' in line) or ('v' in line) or ('e' in line):
                    line = next(f)
                    buff_str += line
                # logging.debug("adding buff_str [%s] to buff_str_list" % (buff_str))
                buff_str_list.append(buff_str)
                buff_str = ''
        except ValueError:
            print("Invalid input:", line)
    f.close()

    return buff_str_list

if __name__ == "__main__":

    import sys

    if (len(sys.argv) != 3):
        usage()
        sys.exit(-1)

    logging.basicConfig(level=logging.INFO)

    classifier_id = sys.argv[1]
    subgraph_id = sys.argv[2]

    logging.info("classifier_id is [%s]" % (classifier_id))
    logging.info("subgraph_id is [%s]" % (subgraph_id))

    subgraphs = load_all_subgraphs_by_classifier_id(int(classifier_id))

    logging.info("subgraph is [%s]" % (str(subgraphs[int(subgraph_id)])))






